<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Brute Force Protection"                              |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.0 / December 2013

*/

if (!defined('CPO')) exit;
$translator->addTranslation('brute_force', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['brute_force'] = array(
    'directory' => $moduleDirectory,
    'caption'   => __('Brute Force Protection'),
	'manage'	=> 'function: brute_force_manage '.$moduleDirectory,
    'install'   => 'function: brute_force_install',
    'activate'  => 'function: brute_force_activate',
    'deactivate'=> 'function: brute_force_deactivate',
    'uninstall' => 'function: brute_force_uninstall',

	// presets
	'active'		  => 'yes',
	'periodinhours'	  => 3,
    'allowedattempts' => 3,
    'sendMail'		  => 'no',
    'sender'		  => $cpoSystem['system_email'],
    'recipient'		  => $cpoSystem['admin_email'],
    'subject'		  => __('Brute Force Protection')." ".$_SERVER['HTTP_HOST']

	);

function brute_force_install()
{
	global $dbPrefix;
    log_brute_force();
    $GLOBALS['message'][] = __('The brute force protection module has been succesfully installed.');
}
function log_brute_force()  {
    global $cpoSystem;
    @mail('kontakt@conpresso4.de','Das Brute Force Protection 4.0 wurde unter '.BASE_ABS.' installiert','','From: '.$cpoSystem['admin_email']);
}
function brute_force_uninstall()
{
	 $GLOBALS['message'][] = sprintf(__('The brute force protection module has been removed from the ConPresso system. Pleases delete the module directory <i>%s</i> to complete the deinstallation.'),$GLOBALS['modules']['brute_force']['directory']);

}
function brute_force_activate()
{
    $GLOBALS['message'][] = __('The brute force protection module has been activated.');
}

function brute_force_deactivate()
{
    $GLOBALS['message'][] = __('The brute force protection module has been deactivated.');
}
function brute_force_manage($moduleDirectory)
{
    global $module_status, $k;
    printIcon(	
        BASE_ABS.$moduleDirectory.'/edit.php', 
        BASE_ABS.'_skin/conpresso/pic_settings.gif', 
        (array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE) ? __('options') : __('not available'),
        array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
    );
}

if(array_key_exists('brute_force', $activeModules) && $activeModules['brute_force']['active']=="yes")  {

    $blockdb = new DB;
    if (!empty($_SESSION['SID_user']['admin'])) {
        // release when logged in
        $query = "UPDATE ".$dbPrefix."_log SET aktion = 'login error' WHERE
            aktion = 'login fail' AND LEFT(bemerkung, '".strlen(gethostbyname($_SERVER['REMOTE_ADDR']))."') = '".gethostbyname($_SERVER['REMOTE_ADDR'])."' ";
        $blockdb->query($query);
    }
    $query = "SELECT count(*) AS attempts FROM ".$dbPrefix."_log WHERE
      aktion = 'login fail' AND LEFT(bemerkung, '".strlen(gethostbyname($_SERVER['REMOTE_ADDR']))."') = '".gethostbyname($_SERVER['REMOTE_ADDR'])."' AND datum > '".date("Y-m-d H:i:s", time() - ($activeModules['brute_force']['periodinhours'] * 60 * 60) )."' ";
    $blockdb->query($query);
    $blockdb->next_record();
    $loginFailCount = $blockdb->v('attempts');

    if ($loginFailCount > $activeModules['brute_force']['allowedattempts']) { // block this attempt
        echo __('Your IP has been blocked for security reasons!');
        exit;
    }
    if ($loginFailCount == $activeModules['brute_force']['allowedattempts'] ) { // last warning
        $message[] = sprintf(__('You have entered a wrong username/password %s times now! On the next failure your IP will be blocked!'), $activeModules['brute_force']['allowedattempts']);
    }


}
?>