<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
define('CPOBACKEND', true); 
require_once('../_include/common.inc.php');

$naction = 'login';

if (empty($_POST['form_userlogin']) && empty($_POST['form_passwort']) && isset($_REQUEST['action'])) {
    $naction = 'failed';
}

if (!isset($_REQUEST['action'])) $_REQUEST['action'] = '';

if ($_REQUEST['action']=='logout' || $_REQUEST['action']=='timeout' || $_REQUEST['action']=='login') {
    $old = session_id();
    session_regenerate_id();
    if (function_exists(fb)) fb('Regenerated session-ID: ' . $old . ' => ' . session_id());
    $_COOKIE[session_name()] = session_id();
	
    if (isset($_SESSION['SID_log_login_id'])) {
        $query = "DELETE FROM ".CPO_LOG_LOGIN." " 
                ."WHERE id='".$_SESSION['SID_log_login_id']."'";
        DEBUG(4, 'Delete user from log_login table.<br /><br />'.$query, __FILE__, __LINE__); 
        $db = new DB;
        $db->query($query);
    }
    
    switch ($_REQUEST['action']) {
    case 'logout':
        logaction('logout', '');
        $naction = 'logout';
        break;
    case 'timeout':
        logaction('timeout', '');
        $naction = 'timeout';
        break;
    }

    // reset session data 
    // we need to destroy the session here because everything else does not work
    // in PHP 4.1.2 where sessions are kinda broken (e.g. session_encode() is):-/
    // other noticed behaviour: session variables are brought back after
    // setting them to "", etc...
    $_SESSION = array();
    session_destroy();
    CPOsession_start();
}

// crypt form_passwort
if (isset($_POST['form_passwort'])) $_POST['form_passwort'] =  md5($_POST['form_passwort']);
else $_POST['form_passwort'] = '';

// if the user is still logged in, set his username and password...
if (isset($_SESSION['SID_log_login_id'])) { 
    $query = "SELECT user, passwd "
            ."FROM ".CPO_USER.", ".CPO_LOG_LOGIN." " 
            ."WHERE ".CPO_USER.".id=".CPO_LOG_LOGIN.".user_id "
            ."AND ".CPO_LOG_LOGIN.".id='".addslashes($_SESSION['SID_log_login_id'])."' ";
    DEBUG(4, 'Is user still logged in?<br /><br />'.$query, __FILE__, __LINE__);   
    $db = new DB;
    $db->query($query);
    $db->next_record();
    $_POST['form_userlogin'] = $db->v('user');
    $_POST['form_passwort']  = $db->v('passwd');
}

$_SESSION['SID_login'] = '';
if (isset($_POST['form_userlogin'])) $_SESSION['SID_login'] = $_POST['form_userlogin'];

if (!empty($_POST['form_userlogin']) && !empty($_POST['form_passwort'])) {
    $query = "SELECT id, name, admin, email, initial, usergroups_id, editor, language "
            ."FROM ".CPO_USER." "
            ."WHERE admin>'0' "
            .'AND id>=0 '
            ."AND user='".addslashes($_POST['form_userlogin'])."' "
            ."AND passwd='".addslashes($_POST['form_passwort'])."'";
    DEBUG(4, $query, __FILE__, __LINE__);   
    $db = new DB;
    $db->query($query);

    if ($db->num_rows()<=0) {
        // no corresponding user with that login / password found.
        session_destroy();
        CPOsession_start();
        include(CPO_BASEDIR.'mod_brute_force/brute_force.inc.php');
        $naction = 'failed';
    } else {
        $db->next_record();

        $hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
        $hostaddr = gethostbyname($_SERVER['REMOTE_ADDR']);
                                                            // FIXME rename for common scheme:
        //$_SESSION['SID_login']                            // SID_user_user 
        // $_SESSION['SID_log_login_id']  
        $_SESSION['SID_user']          = array(
                                            'id'=>$db->v('id'), 
                                            'usergroups_id'=>$db->v('usergroups_id'),
                                            'editor'=>$db->v('editor'), 
                                            'initial'=>$db->v('initial'),
                                            'email'=>$db->v('email'),
                                            'admin'=>$db->v('admin'),
                                            'language'=>$db->v('language'),
                                            'name'=>$db->v('name')
                                        );
        $_SESSION['SID_rubric_secure'] = '';                // SID_rubric_seclevel
        $_SESSION['SID_Rubrik']        = '';                // SID_rubric_name
        $_SESSION['SID_rubric_id']     = '';
        $_SESSION['SID_rubric_source_rubric_id'] = '';
        $_SESSION['SID_rubric_name']   = ''; 

        $_SESSION['SID_IP']             = $hostaddr;
        $_SESSION['SID_pagers']         = array('articles'=>0, 'users'=>0);

        // user was not logged in yet?
        if (!isset($_SESSION['SID_log_login_id'])) {
            $query = "INSERT INTO ".CPO_LOG_LOGIN." "
                    ."(user_id, login, last_action, ip, ip_name, browser) "
                    ."VALUES ("
                    ."'".addslashes($_SESSION['SID_user']['id'])."', " // user_id
                    ."'".date('Y-m-d H:i:s')."', " // login
                    ."'".date('Y-m-d H:i:s')."', " // last_action
                    ."'".addslashes($hostaddr)."', " // ip
                    ."'".addslashes($hostname)."', " // ip_name
                    ."'".$_SERVER['HTTP_USER_AGENT']."') "; // browser
            DEBUG(4, 'Insert this user into _log_login.<br /><br />'.$query, __FILE__, __LINE__);   
            $db->query($query);

            $query = "SELECT last_insert_id()";
            DEBUG(4, 'Get log_login_id of this user.<br /><br />'.$query, __FILE__, __LINE__);   
            $db->query($query);
            $db->next_record();
            $_SESSION['SID_log_login_id'] = $db->v('last_insert_id()');

            logaction('login', '');
        }
    } // if ($db->num_rows()<=0) { } else {
} // if (!empty($_POST['form_userlogin']) && !empty($_POST['form_passwort'])) {

if (!empty($_SESSION['SID_log_login_id'])) {

    // user is logged in

    $_SESSION['SID_navigation_id'] = 0;
    if (isset($_GET['navigation'])) {
        $_t = explode(':', $_GET['navigation']);
        $_SESSION['SID_navigation_id'] = $_t[0];
        $_REQUEST['rubric'] = $_t[1];
    }

    // edit rubric if requested
    if (isset($_REQUEST['rubric']) && $_REQUEST['rubric']!=$_SESSION['SID_rubric_id']) {

        $query = "SELECT id, name, directory, seclevel, source_rubric_id "
                ."FROM ".CPO_RUBRIC." "
                ."WHERE id='".addslashes($_REQUEST['rubric'])."'";
        if ($_REQUEST['rubric']=='') {
            $query = "SELECT '' as id, '' as name, '' as directory, '' as seclevel, '' as source_rubric_id ";
        }
        DEBUG(4, $query, __FILE__, __LINE__);   
        $db = new DB;
        $db->query($query);
        $_SESSION['SID_rubric_id']                  = 0;
        $_SESSION['SID_rubric_name']                = '';
        $_SESSION['SID_rubric_secure']              = 0;
        $_SESSION['SID_rubric_directory']           = '';
        $_SESSION['SID_rubric_source_rubric_id']    = 0;
        if ($_SESSION['SID_rubric_source_rubric_id']==0) // only use SID_rubric_source_rubric_id to fetch the data
            $_SESSION['SID_rubric_source_rubric_id'] = $_SESSION['SID_rubric_id'];

        $_SESSION['SID_pagers']['articles'] = 0;
        while ($db->next_record()) {
            $_SESSION['SID_rubric_id']                  = $db->v('id');
            $_SESSION['SID_rubric_name']                = $db->v('name');
            $_SESSION['SID_rubric_secure']              = $db->v('seclevel');
            $_SESSION['SID_rubric_directory']           = $db->v('directory');
            $_SESSION['SID_rubric_source_rubric_id']    = $db->v('source_rubric_id');
            if ($_SESSION['SID_rubric_source_rubric_id']==0) // only use SID_rubric_source_rubric_id to fetch the data
                $_SESSION['SID_rubric_source_rubric_id'] = $_SESSION['SID_rubric_id'];

            $_SESSION['SID_pagers']['articles'] = 0;
        }
    }

    require(CPO_BASEDIR.'_include/check.php');
} // if (!empty ($_SESSION['log_login_id'])) {

session_write_close(); // store session before loading frames 
CPOsession_start(); // to allow transparent session id support again

$SID = '';
if (empty($_COOKIE[session_name()])) {
	$SID = session_name() . '=' . session_id();
}
?>
<html>
<head>
    <title><?php echo $cpoTitle ?></title>
    <meta name="robots"       content="noindex,nofollow">
    <meta http-equiv="pragma" content="no-cache">
    <script language="JavaScript">
        if (top.frames.length >1) {
            top.location ="<?php print(htmlspecialchars('index.php?action='.$_REQUEST['action'])); ?>";
        }
    </script>
</head>

<frameset rows="116,*" frameborder="no">
    <frame src="<?php echo BASE_REL.'_admin/frame_titel.php?action=' . htmlspecialchars($_REQUEST['action']); ?>" name="cpo_titel" scrolling="no" marginwidth="0" noresize>
    <frameset cols="205,*">
        <?php if (!empty($_SESSION['SID_log_login_id'])) { ?>
            <frame name="cpo_navigation"    scrolling="auto" noresize src="<?php echo BASE_REL.'_admin/frame_navigation.php?'.$SID; ?>" >
            <frame name="cpo_content" scrolling="auto" noresize src="<?php
                if ($_SESSION['SID_rubric_id']=='') echo htmlspecialchars(BASE_REL.'_admin/rubrics.php?first=1&'.$SID);
                else                                echo htmlspecialchars(BASE_REL.'_admin/articles.php?'.$SID);
            ?>">
        <?php } else { ?>
            <frame name="cpo_navigation" scrolling="auto" noresize src="<?php echo BASE_REL.'_admin/frame_navigation.php?'.$SID; ?>">
            <frame name="cpo_content"    scrolling="auto" noresize src="<?php echo BASE_REL.'_admin/login.php?action='.htmlspecialchars($naction).'&amp;rubric=' . htmlspecialchars($_REQUEST['rubric']) . '&amp;'.$SID; ?>">
        <?php } ?>
    </frameset>
</frameset>
</html>